/* $Id: log.c 35 2024-11-04 10:42:21Z nishi $ */

#include <MultiView/CommonLog.h>
#include <MultiView/CommonString.h>

#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>

FILE* MULTIVIEW_PRIVATE(logfile) = NULL;

void MULTIVIEW_PRIVATE(log)(const char* facil, char level, const char* ident, const char* msg) {
	int i;
	char* facil_up = MULTIVIEW_PRIVATE(strdup)(facil);
	char* ident_up = MULTIVIEW_PRIVATE(strdup)(ident);
	char level_up = toupper(level);
	if(MULTIVIEW_PRIVATE(logfile) == NULL) MULTIVIEW_PRIVATE(logfile) = stderr;
	for(i = 0; facil_up[i] != 0; i++) facil_up[i] = toupper(facil_up[i]);
	for(i = 0; ident_up[i] != 0; i++) ident_up[i] = toupper(ident_up[i]);
	fprintf(MULTIVIEW_PRIVATE(logfile), "%%%s-%c-%s, %s\n", facil_up, level_up, ident_up, msg);
	free(facil_up);
	free(ident_up);
}
