/* $Id: memory.c 45 2024-11-10 08:32:28Z nishi $ */

#include "config.h"

#include <MultiView/CommonMemory.h>

#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>
#if !HAVE_SYS_MMAN_H__MAP_ANONYMOUS && HAVE_SYS_MMAN_H__MAP_ANON
#define MAP_ANONYMOUS MAP_ANON
#endif
struct MULTIVIEW_PRIVATE(shptr) {
	void* ptr;
	size_t size;
};
typedef struct MULTIVIEW_PRIVATE(shptr) MULTIVIEW_PRIVATE(shptr_t);
MULTIVIEW_PRIVATE(shptr_t) * *MULTIVIEW_PRIVATE(shptrs) = NULL;

void* MULTIVIEW_PRIVATE(shmalloc)(size_t size) {
	size_t alsize = sysconf(_SC_PAGESIZE) * ((size / sysconf(_SC_PAGESIZE)) + 1);
	void* ptr = mmap(NULL, alsize, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	int i;
	MULTIVIEW_PRIVATE(shptr_t) * *oldptrs;
	if(ptr == NULL) return NULL;
	if(MULTIVIEW_PRIVATE(shptrs) == NULL) {
		MULTIVIEW_PRIVATE(shptrs) = malloc(sizeof(*MULTIVIEW_PRIVATE(shptrs)));
		MULTIVIEW_PRIVATE(shptrs)[0] = NULL;
	}
	oldptrs = MULTIVIEW_PRIVATE(shptrs);
	for(i = 0; oldptrs[i] != NULL; i++);
	MULTIVIEW_PRIVATE(shptrs) = malloc(sizeof(*MULTIVIEW_PRIVATE(shptrs)) * (i + 2));
	for(i = 0; oldptrs[i] != NULL; i++) MULTIVIEW_PRIVATE(shptrs)[i] = oldptrs[i];
	MULTIVIEW_PRIVATE(shptrs)[i] = malloc(sizeof(**MULTIVIEW_PRIVATE(shptrs)));
	MULTIVIEW_PRIVATE(shptrs)[i]->ptr = ptr;
	MULTIVIEW_PRIVATE(shptrs)[i]->size = alsize;
	MULTIVIEW_PRIVATE(shptrs)[i + 1] = NULL;
	free(oldptrs);
	return ptr;
}

void MULTIVIEW_PRIVATE(shfree)(void* ptr) {
	int len = 0;
	int incr = 0;
	int i;
	MULTIVIEW_PRIVATE(shptr_t) * *oldptrs;
	if(MULTIVIEW_PRIVATE(shptrs) == NULL) return;
	oldptrs = MULTIVIEW_PRIVATE(shptrs);
	for(i = 0; oldptrs[i] != NULL; i++) {
		if(oldptrs[i]->ptr == ptr) {
			munmap(oldptrs[i]->ptr, oldptrs[i]->size);
		} else {
			len++;
		}
	}
	MULTIVIEW_PRIVATE(shptrs) = malloc(sizeof(*MULTIVIEW_PRIVATE(shptrs)) * (len + 1));
	for(i = 0; oldptrs[i] != NULL; i++) {
		if(oldptrs[i]->ptr != ptr) {
			MULTIVIEW_PRIVATE(shptrs)[incr++] = oldptrs[i];
		}
	}
	free(oldptrs);
}
