/* $Id: Module.h 38 2024-11-10 05:13:43Z nishi $ */

#ifndef __MULTIVIEW_MODULE_H__
#define __MULTIVIEW_MODULE_H__

#include <MultiView/Macro.h>

#include <stddef.h>

enum MULTIVIEW_PRIVATE(module_info_numbers) {
	MULTIVIEW_PRIVATE(MODULE_GET_NAME),
	MULTIVIEW_PRIVATE(MODULE_GET_VERSION),
	MULTIVIEW_PRIVATE(MODULE_GET_IDENT)
};

enum MULTIVIEW_PRIVATE(module_init_numbers) {
	MULTIVIEW_PRIVATE(MODULE_INIT_SUCCESS),
	MULTIVIEW_PRIVATE(MODULE_INIT_FAIL),
};

#define __MULTIVIEW_MODULE_DECL(name, ident, version) \
	void* module_get_info(int number) { \
		if(number == MULTIVIEW_PRIVATE(MODULE_GET_NAME)) { \
			return (void*)name; \
		} else if(number == MULTIVIEW_PRIVATE(MODULE_GET_VERSION)) { \
			return (void*)version; \
		} else if(number == MULTIVIEW_PRIVATE(MODULE_GET_IDENT)) { \
			return (void*)ident; \
		} else { \
			return NULL; \
		} \
	}
typedef void* (*MULTIVIEW_PRIVATE(module_get_info_t))(int number);
typedef int (*MULTIVIEW_PRIVATE(module_init_t))(void);

#endif
